//  - http://www.indiscripts.com/post/2009/10/work-around-the-width-height-gap

// TRACK 1 -- naive "getDims" function
 
function naive_getDims(/*PageItem*/obj, /*bool*/visible)
// return the [width,height] of <obj>
// according to its (geometric|visible)Bounds
{
var boundsProperty = ((visible)?'visible':'geometric')+'Bounds';
var b = obj[boundsProperty];
// width=right-left , height = bottom-top
return [ b[3]-b[1] , b[2]-b[0] ];
}
 
// sample code
var pItem = app.selection[0]; // get the selected object
alert('  (  ): ' + naive_getDims(pItem));
alert(' (+): ' + naive_getDims(pItem, true));
alert('   : ' + improved_getDims(pItem, true));
alert('   INFO...: ' + adjusted_getDims(pItem, true));
alert('  pt (   ): ' + getDims(pItem, true));




// TRACK 2 -- improved "getDims" function
 
function improved_getDims(/*PageItem*/obj, /*bool*/visible)
// return the [width,height] of <obj>
// according to its (geometric|visible)Bounds
{
var boundsProperty = ((visible)?'visible':'geometric')+'Bounds';
 
// store rotation/shear angles
var ra = obj.rotationAngle;
var sa = obj.shearAngle;
 
// apply 'zero' angles (temporarily)
obj.rotationAngle = 0;
obj.shearAngle = 0;
 
// now, get the bounds
var b = obj[boundsProperty];
 
// restore rotation/shear angles
obj.rotationAngle = ra;
obj.shearAngle = sa;
 
return [ b[3]-b[1] , b[2]-b[0] ];
}
 
 
 // TRACK 3 -- adjusted "getDims" function
 
function adjusted_getDims(/*PageItem*/obj, /*bool*/visible)
// return the [width,height] of <obj>
// according to its (geometric|visible)Bounds
{
var boundsProperty = ((visible)?'visible':'geometric')+'Bounds';
 
// store rotation/shear angles
var ra = obj.rotationAngle;
var sa = obj.shearAngle;
 
// apply 'zero' angles (temporarily)
obj.rotationAngle = 0;
obj.shearAngle = 0;
 
// now, get the bounds
var b = obj[boundsProperty];
 
// restore rotation/shear angles
obj.rotationAngle = ra;
obj.shearAngle = sa;
 
// calculate the width and the height
var w = b[3]-b[1];
var h = (b[2]-b[0]) / Math.cos(sa*Math.PI/180);
return [w,h];
}
 
 
 function getDims(/*PageItem*/obj, /*bool*/visibleBounds)
// Return *IN POINTS* the actual [width,height] of the page item
{
var boxLimits = BoundingBoxLimits[
    (visibleBounds)?
    'OUTER_STROKE_BOUNDS':
    'GEOMETRIC_PATH_BOUNDS'
    ];
 
var getCoords = function(cornerPt)
    { // <this>: PageItem - return [x,y]
    return this.resolve([cornerPt,boxLimits],
        CoordinateSpaces.innerCoordinates)[0];
    }
 
// get [left,top, right,bottom] inner coordinates
var coords = getCoords.call(obj,AnchorPoint.topLeftAnchor).
    concat(getCoords.call(obj,AnchorPoint.bottomRightAnchor));
 
// calculate the width and the height
var sa = obj.shearAngle;
var w = coords[2]-coords[0];
var h = ( coords[3]-coords[1] ) / Math.cos(sa*Math.PI/180);
return [w,h];
}